package controller;

import java.util.HashMap;
import java.util.Map;

import javax.portlet.ActionRequest;
import javax.portlet.ActionResponse;
import javax.portlet.RenderRequest;
import javax.portlet.RenderResponse;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.springframework.web.portlet.SimplePortletFormController;
import org.springframework.web.portlet.support.PortletController;
import org.springframework.web.servlet.ModelAndView;

import bus.ProductManager;


/**
 * NOTE: could implement PortletController directly if it class does not require
 *       the basic FormController config.
 */
public class SpringPortletViewController extends SimplePortletFormController {
    protected final Log logger = LogFactory.getLog(getClass());

    private ProductManager productManager;
    
    /**
     * @return Returns the productManager.
     */
    public ProductManager getProductManager() {
        return productManager;
    }
    
    /**
     * @param productManager The productManager to set.
     */
    public void setProductManager(ProductManager prodMan) {
        this.productManager = prodMan;
    }
    
	/**
	 * @see org.springframework.web.portlet.support.PortletController#handleRequest(javax.portlet.RenderRequest, javax.portlet.RenderResponse)
	 */
	public ModelAndView handleRequest(RenderRequest request, RenderResponse response) throws Exception {
        String now = (new java.util.Date()).toString(); 
        logger.info("returning hello view with " + now);

        Map myModel = new HashMap();
        myModel.put("now", now);
        myModel.put("products", getProductManager().getProducts());

        return new ModelAndView(this.getFormView(), "model", myModel);
	}
	
	/**
	 * @see org.springframework.web.portlet.support.PortletController#handleRequest(javax.portlet.ActionRequest, javax.portlet.ActionResponse)
	 */
	public void handleRequest(ActionRequest request, ActionResponse response) throws Exception {
			
	}	
}
