package controller;

import java.util.HashMap;
import java.util.Map;

import javax.portlet.PortletRequest;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.springframework.web.portlet.SimplePortletFormController;
import org.springframework.web.servlet.ModelAndView;

import bus.PriceIncrease;
import bus.ProductManager;


public class SpringPortletEditController extends SimplePortletFormController {

    /** Logger for this class and subclasses */
    protected final Log logger = LogFactory.getLog(getClass());

    private ProductManager productManager;
    
    
    /**
     * @return Returns the productManager.
     */
    public ProductManager getProductManager() {
        return productManager;
    }
    
    /**
     * @param productManager The productManager to set.
     */
    public void setProductManager(ProductManager productMananager) {
        this.productManager = productMananager;
    }
    
    /**
     * @see org.springframework.web.portlet.SimplePortletFormController#formBackingObject(javax.portlet.PortletRequest)
     */
    protected Object formBackingObject(PortletRequest request) throws Exception {
        PriceIncrease priceIncrease = new PriceIncrease();
        priceIncrease.setPercentage(20);

        return priceIncrease;
    }
    
    /**
     * @see org.springframework.web.portlet.SimplePortletFormController#onSubmit(java.lang.Object)
     */
    public ModelAndView onSubmit(Object command) {
        int increase = ((PriceIncrease) command).getPercentage();
        logger.info("Increasing prices by " + increase + "%.");

        productManager.increasePrice(increase);

        String now = (new java.util.Date()).toString();
        logger.info("returning from PriceIncreaseForm view to " + getSuccessView() + " with " + now);

        Map myModel = new HashMap();
        myModel.put("now", now);
        myModel.put("products", getProductManager().getProducts());

        return new ModelAndView(getSuccessView(), "model", myModel);

    }    
}
